#include <stream.h>
#include <rpc/rpc.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/prctl.h>
#include <signal.h>
#include <sys/time.h>
#include <unistd.h>
#include <limits.h>
#include <bstring.h>

#include "rtrack_svc.h"

void *
rtinit_1( void * , struct svc_req * ) 
{
        extern int FRAMEZERO;
	int null=0;
	FRAMEZERO = 1;
	return (void*)&null;
}

extern "C" {
      extern float region_centroid[2], region_major_axis[2], region_minor_axis[2];
}

rtresult *rtgetstats_1( void *, struct svc_req * ) 
{
      static rtresult result;
      result.centroid[0] = region_centroid[0]; 
      result.centroid[1] = region_centroid[1];
      result.major_axis[0] = region_major_axis[0];
      result.major_axis[1] = region_major_axis[1];
      result.minor_axis[0] = region_minor_axis[0];
      result.minor_axis[1] = region_minor_axis[1];
      return &result;
}

void *
rtexit_1( void *, struct svc_req * ) 
{
        extern int RPCEXITCMD;
	int null=0;
	RPCEXITCMD = 1;
	return (void*)&null;
}

void
serverThread( void * )
{
  signal(SIGTERM,SIG_DFL);
  rpc_init();
  svc_run();
}

int child_pid;

void 
startRpcServer( void) {
      unsigned int inh = PR_SALL | PR_SETEXITSIG;
      child_pid = sproc( serverThread, inh );
      cerr << "starting RPC server thread" << endl;
      if( -1 == child_pid )
	perror( "pfinder: sproc failed" ), exit(1);
}

void
stopRpcServer(void) {
      signal(SIGTERM,SIG_IGN);
      kill(child_pid, SIGTERM);
}
